# Noise Class Reference

`#include <noise.h>`

Inheritance diagram for Noise:

List of all members.

## Public Member Functions

| Noise ()
virtual bool | set_param (const synfig::String &param, const synfig::ValueBase &value)
| Sets the parameter described by param to value.
virtual synfig::ValueBase | get_param (const synfig::String &param) const
| Get the value of the specified parameter.
virtual synfig::Color | get_color (synfig::Context context, const synfig::Point &pos) const
| Gets the color of the Canvas at pos.
virtual bool | accelerated_render (synfig::Context context, synfig::Surface *surface, int quality, const synfig::RendDesc &renddesc, synfig::ProgressCallback *cb) const
| Renders the Canvas to the given Surface in an accelerated manner.
synfig::Layer::Handle | hit_check (synfig::Context context, const synfig::Point &point) const
| Checks to see if a part of the layer is directly under point.
virtual void | set_time (synfig::Context context, synfig::Time time) const
| Sets the time for the selected Layer and those under it.
virtual void | set_time (synfig::Context context, synfig::Time time, const synfig::Point &point) const
| Sets the time for the selected Layer and those under it for a specific point.
virtual Vocab | get_param_vocab () const
| Gets the parameter vocabulary.

## Constructor & Destructor Documentation

Noise::Noise | ( |  | ) |

References RandomNoise::set_seed(), and RandomNoise::SMOOTH_COSINE.

## Member Function Documentation

bool Noise::set_param | ( | const synfig::String & | param,
|  | const synfig::ValueBase & | value |
| ) |  |  | `[virtual]`

Sets the parameter described by param to value.

Parameters:

  | param | The name of the parameter to set
  | value | What the parameter is to be set to.

Returns:
  `true` on success, `false` upon rejection or failure. If it returns `false`, then the Layer is assumed to remain unchanged.

See also:
  get_param()

Todo:
  param should be of the type `const String &param`

Reimplemented from synfig::Layer_Composite.

References synfig::ValueBase::get(), IMPORT, synfig::ValueBase::same_type_as(), and RandomNoise::set_seed().

ValueBase Noise::get_param | ( | const synfig::String & | param | ) | const`[virtual]`

Get the value of the specified parameter.

Returns:
  The requested parameter value, or (upon failure) a NIL ValueBase.

See also:
  set_param()

Todo:
  param should be of the type `const String &`

Reimplemented from synfig::Layer_Composite.

References EXPORT, EXPORT_NAME, EXPORT_VERSION, and RandomNoise::get_seed().

Color Noise::get_color | ( | synfig::Context | context,
|  | const synfig::Point & | pos |
| ) |  |  | const`[virtual]`

Gets the color of the Canvas at pos.

Parameters:

  | context | Context iterator referring to next Layer.
  | pos | Point which indicates where the Color should come from

See also:
  Handle::get_color()

Reimplemented from synfig::Layer.

References synfig::Layer_Composite::get_amount(), synfig::Layer_Composite::get_blend_method(), and synfig::Context::get_color().

bool Noise::accelerated_render | ( | synfig::Context | context,
|  | synfig::Surface * | surface,
|  | int | quality,
|  | const synfig::RendDesc & | renddesc,
|  | synfig::ProgressCallback * | cb |
| ) |  |  | const`[virtual]`

Renders the Canvas to the given Surface in an accelerated manner.

Parameters:

  | context | Context iterator referring to next Layer.
  | surface | Pointer to Surface to render to.
  | quality | The requested quality-level to render at.
  | renddesc | The associated RendDesc.
  | cb | Pointer to callback object. May be NULL if there is no callback.

Returns:
  `true` on success, `false` on failure

See also:
  Handle::accelerated_render()

Reimplemented from synfig::Layer_Composite.

References std::abs(), synfig::Context::accelerated_render(), synfig::ProgressCallback::amount_complete(), f, synfig::Layer_Composite::get_amount(), synfig::Layer_Composite::get_blend_method(), synfig::RendDesc::get_h(), synfig::RendDesc::get_ph(), synfig::RendDesc::get_pw(), synfig::RendDesc::get_tl(), and synfig::RendDesc::get_w().

synfig::Layer::Handle Noise::hit_check | ( | synfig::Context | context,
|  | const synfig::Point & | point |
| ) |  |  | const`[virtual]`

Checks to see if a part of the layer is directly under point.

Parameters:

  | context | Context iterator referring to next Layer.
  | point | The point to check

Returns:
  The handle of the layer under point. If there is not a layer under point, then returns an empty handle.

Reimplemented from synfig::Layer.

References synfig::Layer_Composite::get_amount(), synfig::Layer_Composite::get_blend_method(), and synfig::Context::hit_check().

void Noise::set_time | ( | synfig::Context | context,
|  | synfig::Time | time |
| ) |  |  | const`[virtual]`

Sets the time for the selected Layer and those under it.

Parameters:

  | context | Context iterator referring to next Layer.
  | time | writeme

See also:
  Handle::set_time()

Reimplemented from synfig::Layer.

References synfig::Context::set_time().

void Noise::set_time | ( | synfig::Context | context,
|  | synfig::Time | time,
|  | const synfig::Point & | point |
| ) |  |  | const`[virtual]`

Sets the time for the selected Layer and those under it for a specific point.

Parameters:

  | context | Context iterator referring to next Layer.
  | time | writeme
  | point | writeme

See also:
  Handle::set_time()

Todo:
  point should be of the type `const Point &`

Reimplemented from synfig::Layer.

References synfig::Context::set_time().

Layer::Vocab Noise::get_param_vocab | ( | void |  | ) | const`[virtual]`

Gets the parameter vocabulary.

Reimplemented from synfig::Layer_Composite.

References _, synfig::Layer::set_description(), RandomNoise::SMOOTH_COSINE, RandomNoise::SMOOTH_CUBIC, RandomNoise::SMOOTH_DEFAULT, RandomNoise::SMOOTH_LINEAR, and RandomNoise::SMOOTH_SPLINE.

The documentation for this class was generated from the following files:

- noise.h
- noise.cpp